function DatabaseHelper() {

    that = this;
}

DatabaseHelper.prototype.setup = function (callback) {

    //First, setup the database
    try {
        this.db = window.openDatabase("asa", "", "Asa", 1000000);
        
    
    this.db.transaction(this.initDB, this.dbErrorHandler, callback);

}
//Geenric database error handler. Won't do anything for now.
DatabaseHelper.prototype.dbErrorHandler = function (e) {
    console.log('DB Error');
    console.log(JSON.stringify(e));
}
//I initialize the database structure

DatabaseHelper.prototype.initDB = function (t) {
    console.log('initDB');
    var sql = 'create table if not exists Plan (id INTEGER PRIMARY KEY AUTOINCREMENT, statusType INTEGER,' +
        ' startDate INTEGER , endDate INTEGER, contactPersons TEXT, organization TEXT, city TEXT, street TEXT,' +
        ' number TEXT, zipcode TEXT, department TEXT, repeatGroup INTEGER ,repeatUtil INTEGER ' +
        ', reasonId INTEGER , comments TEXT, extra TEXT , confirmed TEXT, reserve TEXT)';
    t.executeSql(sql);

    var sql = 'ALTER TABLE Plan ADD reserve TEXT)';
    t.executeSql(sql);
    
}

DatabaseHelper.prototype.getEntries = function (start, callback) {
    console.log('Running getEntries');
    that = this;
    if (arguments.length === 1)
        callback = arguments[0];

    this.db.transaction(function (t) {
        var sql = 'select id ,statusType  ,startDate ,endDate,contactPersons , organization, city, street, number, zipcode, department ,repeatGroup ,repeatUtil  ,reasonId ,comments, extra , confirmed, reserve from Plan order by id desc';

        t.executeSql(sql, [], function (t, results) {
            callback(that.fixResults(results));
        }, this.dbErrorHandler);
    }, this.dbErrorHandler);

}

DatabaseHelper.prototype.getEntriesByType = function (callback, statusType) {
    console.log('Running getEntriesByType');
    that = this;
    var date1 = new Date();
    date1.setHours(0);
    date1.setMinutes(0);
    var date2 = new Date();
    date2.setHours(0);
    date2.setMinutes(0)
    date2 = date2.addDays2(8 * 7);

    var timestamp = date1.getTime();
    var timestamp2 = date2.getTime();

    var clone = statusType.slice(0);

    this.db.transaction(function (t) {
        var sql = 'select id ,statusType  ,startDate ,endDate,contactPersons , organization, city, street, number, zipcode , department,repeatGroup ,repeatUtil  ,reasonId   ,comments, extra , confirmed, reserve from Plan  ';

        sql += ' where endDate > ? AND startDate < ?';
        if (clone.length > 0) {
            sql += ' AND ( statusType= ? ';
        }
        if (clone.length > 1) {

            for (var i = 1; i < clone.length; i++) {
                sql += ' OR statusType =? ';

            }
            sql += ' )';
        } else {
            if (clone.length > 0) {
                sql += ' )';
            }
        }
        sql += ' order by startDate ASC '
        clone.splice(0, 0, timestamp);
        clone.splice(1, 0, timestamp2);

        t.executeSql(sql, clone, function (t, results) {
            callback(that.fixResults(results));
        }, this.dbErrorHandler);
    }, this.dbErrorHandler);

}


DatabaseHelper.prototype.getEntry = function (id, callback) {
    console.log("getEntry");

    that = this;
    this.db.transaction(function (t) {
        var sql = 'select id ,statusType  ,startDate ,endDate  ,contactPersons , organization, city, street, number, zipcode, department,repeatGroup ,repeatUtil  ,reasonId   ,comments, extra , confirmed, reserve from Plan where id= ? ';
        t.executeSql(sql, [id], function (t, results) {
            callback(that.fixResult(results));
        }, this.dbErrorHandler);
    }, this.dbErrorHandler);

}

DatabaseHelper.prototype.saveEntry = function (record, callback) {
    console.log("saveEntry");
    this.db.transaction(function (t) {
        var sql = 'insert into Plan(statusType  , startDate , endDate  ,contactPersons , organization, city, street, number, zipcode, department, repeatGroup , repeatUtil  , reasonId   , comments, extra , confirmed, reserve ) values(?,?,?, ?,?,?, ?,?,? ,?,?,?,?,?,?,?,?) ';
        t.executeSql(sql, [record.statusType, record.startDate.getTime(), record.endDate.getTime(), JSON.stringify(record.contactPersons), record.organization, record.city, record.street, record.number, record.zipcode, record.department, record.repeatGroup, record.repeatUtil.getTime(), record.reasonId, record.comments, record.extra , record.confirmed, record.reserve], function () {
            callback();
        }, this.dbErrorHandler);
    }, this.dbErrorHandler);

}

DatabaseHelper.prototype.deleteRecords = function () {
    console.log("deleteRecords");
    this.db.transaction(function (t) {
        var sql = 'DELETE  FROM Plan ';
        t.executeSql(sql);
    }, this.dbErrorHandler);

}


DatabaseHelper.prototype.updateEntry = function (record, callback) {
    console.log("updateEntry");
    this.db.transaction(function (t) {
        var sql = 'UPDATE Plan Set statusType= ? , startDate= ? , endDate= ?  ,contactPersons= ?  , organization= ?  ,city= ? ,street= ? ,number= ? ,zipcode= ? , department= ? , repeatGroup= ? , repeatUtil= ?  , reasonId= ?   , comments= ? , extra= ? , confirmed=?, reserve=? where id= ? ';
        t.executeSql(sql, [record.statusType, record.startDate.getTime(), record.endDate.getTime(), JSON.stringify(record.contactPersons), record.organization, record.city, record.street, record.number, record.zipcode, record.department, record.repeatGroup, record.repeatUtil.getTime(), record.reasonId, record.comments , record.extra , record.confirmed, record.reserve , record.id], function () {
            callback();
        }, this.dbErrorHandler);
    }, this.dbErrorHandler);
}


//Utility to convert record sets into array of obs
DatabaseHelper.prototype.rowToRecord = function (row) {
    var record = new Record();
    console.log(JSON.stringify(row));

    record.id = row.id;
    record.statusType = row.statusType;
    record.startDate = new Date();
    record.startDate.setTime(row.startDate);

    record.endDate = new Date();
    record.endDate.setTime(row.endDate);
    record.selMon = row.selMon;
    record.selTues = row.selTues;
    record.selWed = row.selWed;
    record.selThu = row.selThu;
    record.selFri = row.selFri;
    record.selSat = row.selSat;
    record.selSun = row.selSun;
    record.repeatGroup = row.repeatGroup;
    record.repeatUtil = new Date();
    record.repeatUtil.setTime(row.repeatUtil);
    record.reasonId = row.reasonId;
    record.comments = row.comments;
    record.contactPersons = JSON.parse(row.contactPersons);
    record.organization = row.organization;
    record.city = row.city;
    record.street = row.street;
    record.number = row.number;
    record.zipcode = row.zipcode;
    record.extra = row.extra;
    record.confirmed = row.confirmed;
    record.reserve = row.reserve;

    record.department = row.department;
    console.log(JSON.stringify(record));
    return record;
}
//Utility to convert record sets into array of obs
DatabaseHelper.prototype.fixResults = function (results) {
    var result = [];

    console.log('sdfddf' + results.rows.length);
    for (var i = 0, len = results.rows.length; i < len; i++) {

        var record;
        var row = results.rows.item(i);

        record = this.rowToRecord(row);

        result.push(record);
    }
    return result;
}
//I'm a lot like fixResults, but I'm only used in the context of expecting one row, so I return an ob, not an array
DatabaseHelper.prototype.fixResult = function (res) {
    if (res.rows.length) {
        return rowToRecord(res.rows.item(0));
    } else
        return {};
}