function Record() {

    this.id = -1;
    this.statusType = 0;
    this.confirmed=false;
    this.reserve=false;
    this.startDate = new Date();
    this.startDate.setHours(8);
    this.startDate.setMinutes(30);
    this.endDate = new Date();
    this.endDate.setHours(17);
    this.endDate.setMinutes(0);

    this.repeatGroup = -1;
    this.repeatUtil = new Date();
    this.repeatUtil.setHours(17);
    this.repeatUtil.setMinutes(0);
    this.reasonId = -1;
    this.comments = '';
    this.extra = '';
    this.organization = '';
    this.city = '';
    this.street = '';
    this.number = '';
    this.zipcode = '';

    this.department = '';

    this.selMon = 0;
    this.selTues = 0;
    this.selWed = 0;
    this.selThu = 0;
    this.selFri = 0;
    this.selSat = 0;
    this.selSun = 0;
    this.contactPersons = [];

};


function ContactPerson(PhoneNumber, FullName) {
    this.PhoneNumber = PhoneNumber;
    this.FullName = FullName;
};


Record.prototype.resetAll = function () {

    this.id = -1;
    this.statusType = 0;
    this.confirmed=false;
    this.reserve=false;
    this.startDate = new Date();
    this.endDate = new Date();
    this.startDate.setHours(8);
    this.startDate.setMinutes(30);
    this.endDate.setHours(17);
    this.endDate.setMinutes(0);
    this.selMon = 0;
    this.selTues = 0;
    this.selWed = 0;
    this.selThu = 0;
    this.selFri = 0;
    this.selSat = 0;
    this.selSun = 0;
    this.repeatGroup = -1;
    this.repeatUtil = new Date();
    this.repeatUtil.setHours(17);
    this.repeatUtil.setMinutes(0);
    this.reasonId = -1;
    this.comments = '';
    this.extra = '';
    this.organization = '';
    this.city = '';
    this.street = '';
    this.number = '';
    this.zipcode = '';

    this.department = '';
};

Record.prototype.resetDays = function () {
    this.selMon = 0;
    this.selTues = 0;
    this.selWed = 0;
    this.selThu = 0;
    this.selFri = 0;
    this.selSat = 0;
    this.selSun = 0;
};

Record.prototype.shouldSplit = function () {
    return this.selMon || this.selTues || this.selWed || this.selThu || this.selFri || this.selSat || this.selSun;
};

Record.prototype.split = function () {

    var array = new Array();

    if (this.shouldSplit()) {
        var arrayDays = this.getDates(this.startDate, this.repeatUtil, this.setDaysArray());

        for (var i = 0; i < arrayDays.length; i++) {

            var cloned = jQuery.extend(true, {}, this);

            var stHours = cloned.startDate.getHours();
            var stMinutes = cloned.startDate.getMinutes();
            var endHours = cloned.endDate.getHours();
            var endMinutes = cloned.endDate.getMinutes();

            cloned.startDate = arrayDays[i].clone();
            cloned.startDate.setHours(stHours);
            cloned.startDate.setMinutes(stMinutes);

            cloned.endDate = arrayDays[i].clone();
            cloned.endDate.setHours(endHours);
            cloned.endDate.setMinutes(endMinutes);

            if (i > 0) {
                cloned.id = -1;
            }
            array.push(cloned);
        }

    } else {
        array.push(this);

    }

    return array;


};

Record.prototype.setDaysArray = function () {
    var array = new Array();
    if (this.selMon === 1) {
        array.push(1);
    }
    if (this.selTues === 1) {
        array.push(2);
    }
    if (this.selWed === 1) {
        array.push(3);
    }
    if (this.selThu === 1) {
        array.push(4);
    }
    if (this.selFri === 1) {
        array.push(5);
    }
    if (this.selSat === 1) {
        array.push(6);
    }
    if (this.selSun === 1) {
        array.push(0);
    }

    return array;
}


Record.prototype.setSelectedDay = function (day, selected) {
    switch (day) {
        case "mo":
            this.selMon = selected;
            break;
        case "tu":
            this.selTues = selected;
            break;
        case "we":
            this.selWed = selected;
            break;
        case "th":
            this.selThu = selected;
            break;
        case "fr":
            this.selFri = selected;
            break;
        case "sa":
            this.selSat = selected;
            break;
        case "su":
            this.selSun = selected;
            break;
    }
};

Record.prototype.getAddress = function () {
    var string = this.organization + "<br />" + this.street + " " + this.number + "<br />" + this.zipcode + " " + this.city;

    return string;
}


Record.prototype.getDates = function (startDate, stopDate, days) {
    var dateArray = new Array();

    var currentDate = startDate;
    while (currentDate <= stopDate) {
        var day = currentDate.getDay();
        if ($.inArray(day, days) != -1) {
            dateArray.push(currentDate);
        }

        currentDate = currentDate.addDays2(1);
    }
    return dateArray;
};





