function Webservice() {
    this.that = this;

    //this.base_url = "https://mobileapptest.creyfs.nl/ASATalent"; /// TEST
    this.base_url = "https://mobileapp.asatalent.nl"; /// LIVE

    this.url_signup = "/api/account/signup/";
    this.url_get_availability = "/api/availability/getavailability/";
    this.url_set_availability = "/api/availability/setavailability/";
}

Webservice.prototype.httpRequest = function (url, method, headers, params, options, win, fail) {
    
    var onLoad = function() {
        var response = new Object();
        response.body = this.responseText;
        response.code = this.status.toString();
        win(response);
    };
    
    var onError = function() {
        var response = new Object();
        response.body = this.responseText;
        response.code = this.status.toString();
        fail(response);
    }
    
    var request = new XMLHttpRequest();

    request.addEventListener("load", onLoad);
    request.addEventListener("error", onError);
    
    if (method === "get")
    {
        var list = [];
        for (var p in params) {
            if (params.hasOwnProperty(p))
                list.push(encodeURIComponent(p) + "=" + encodeURIComponent(params[p]));
        }
        
        url = url + "?" + list.join("&");
    }
    
    request.open(method, url);
    
    for (var header in headers) {
        if (headers.hasOwnProperty(header)) {
            request.setRequestHeader(header, headers[header]);
        }
    }
    
    request.setRequestHeader("Content-Type", "application/json");
    
    if (method === "post")
        request.send(params.json);
    else
        request.send();
}

Webservice.prototype.signup = function (Email, Name, win, fail) {
    var that = this;

    app.getToken(function (token) {
        var httpOptions = {
            trustAll: true
        };

        var params = {
            email: Email,
            language: window.lang.curentLanguage
        };
        console.log(JSON.stringify(token));
        var headers = token.getHeaderLogin();
        var apiUrl = that.base_url + '' + that.url_signup;
                 
        that.httpRequest(apiUrl, 'get', headers, params, httpOptions, win, fail);
    });
};

Webservice.prototype.get_availability = function (win, fail) {
    var that = this;
    app.getToken(function (token) {

        var httpOptions = {
            trustAll: true
        };
        console.log(JSON.stringify(token));
        var headers = token.getHeader();

        var params = {

        };

        var apiUrl = that.base_url + '' + that.url_get_availability;

        that.httpRequest(apiUrl, 'get', headers, params, httpOptions, function (response) {
            var code = response.code;
            var message = response.message;
            var body = response.body;


            console.log("response "+JSON.stringify(response));

            if (response.code != 300) {
                var records = that.convertToRecords((jQuery.parseJSON(body)).TimeIntervals);
                win(records);
            } else {
                app.changeRegistrationCode(response.body);
                fail(response);
            }


        }, fail);
    });
};

Webservice.prototype.set_availability = function (records, win, fail) {
    that = this;
    app.getToken(function (token) {
        var httpOptions = {
            trustAll: true
        };

        console.log(JSON.stringify(token));
        var headers = token.getHeader();

        var params = {
            json: JSON.stringify(that.getReportedTime(records))
        };

        var apiUrl = that.base_url + '' + that.url_set_availability;

         that.httpRequest(apiUrl, 'post', headers, params, httpOptions, win, fail);
    });

};

Webservice.prototype.convertToRecords = function (items) {
    console.log('preresult' + JSON.stringify(items));
    var result = [];
    for (var i = 0, len = items.length; i < len; i++) {

        var record;
        var row = items[i];
        console.log('herenow = ' + JSON.stringify(row));

        record = this.convertToRecord(row);

        console.log('herethen = ' + JSON.stringify(record));

        result.push(record);
    }
    console.log('result' + JSON.stringify(result));

    return result;
};

Webservice.prototype.convertToRecord = function (item) {
    console.log('result2' + JSON.stringify(item));
    var record = new Record();

    record.startDate = moment(item.StartDateTime, "YYYY-MM-DD'T'HH:mm:ss").toDate();
    record.endDate = moment(item.EndDateTime, "YYYY-MM-DD'T'HH:mm:ss").toDate();

    //record.repeatGroup = -1;
    //record.repeatUtil = curentDateTime;
    //record.reasonId = -1;
    record.comments = item.Remark;
    record.extra = item.ReferenceInfo.Remark;
    record.contactPersons = item.ReferenceInfo.ContactPersons;

    record.confirmed =  item.Confirmed;
    record.reserve =  item.ReferenceInfo.Reserve;
    console.log('here3 = ' + item.ReferenceInfo.Reserve);
    console.log('here4 = ' + record.reserve);

    record.organization = item.ReferenceInfo.Organization;
    record.city = item.ReferenceInfo.AddressCity;
    record.street = item.ReferenceInfo.AddressStreet;
    record.number = item.ReferenceInfo.AddressNumber;
    record.zipcode = item.ReferenceInfo.AddressZipcode;

    record.department = item.ReferenceInfo.Department;
    switch (item.Type) {
        case ' Available':
            record.statusType = 0;
            break;
        case 'NotAvailable':
            record.statusType = 1;
            break;
        case 'Planned':
            record.statusType = 2;
            break;
        default:
            record.statusType = 0;
    }
    return record;
};

Webservice.prototype.convertToTimeInterval = function (item) {
    var TimeIntervals = new Object();
    var ReferenceInfo = new Object();
    TimeIntervals.Remark = item.comments;
    TimeIntervals.ReasonOfUnavailability = '';
    switch (item.statusType) {
        case 0:
            //Available
            TimeIntervals.Type = 'Available';
            break;
        case 1:
            //Not Available
            TimeIntervals.Type = 'NotAvailable';
            break;
        case 2:
            //Planned
            TimeIntervals.Type = 'Planned';
            break;
    }


    TimeIntervals.StartDateTime = (moment(item.startDate)).format("YYYY-MM-DDTHH:mm:ss");
    TimeIntervals.EndDateTime = (moment(item.endDate)).format("YYYY-MM-DDTHH:mm:ss");
    // TimeIntervals.StartDateTime = item.startDate;
    //TimeIntervals.EndDateTime = item.endDate;

    //TimeIntervals.StartDateTime2 = item.startDate;
    // TimeIntervals.EndDateTime2 = item.endDate;

    TimeIntervals.Confirmed = item.confirmed;
    TimeIntervals.Reserve = item.reserve;
    ///TimeIntervals.Confirmed = false;

    ReferenceInfo.Extra = '';
    ReferenceInfo.Remark = item.extra || "";
    ReferenceInfo.AddressCity = item.city || "";
    ReferenceInfo.AddressNumber = item.number || "";
    ReferenceInfo.AddressStreet = item.street || "";
    ReferenceInfo.AddressZipcode = item.zipcode || "";
    ReferenceInfo.Department = item.Department || "";
    ReferenceInfo.Organization = item.organization || "";

    ReferenceInfo.ContactPerson = item.contactPersons || "";

    TimeIntervals.ReferenceInfo = ReferenceInfo;

    return TimeIntervals;
};

Webservice.prototype.convertToTimeIntervals = function (items) {
    var result = [];
    for (var i = 0, len = items.length; i < len; i++) {

        var record;
        var row = items[i];

        record = this.convertToTimeInterval(row);

        result.push(record);
    }
    return result;

};

Webservice.prototype.getReportedTime = function (records) {
    var startDate = new Date();
    startDate.setFullYear(2050);
    var endDate = new Date();
    endDate.setFullYear(2000);
    for (var i = 0; i < records.length; i++) {
        var record = records[i];
        if (record.startDate < startDate) {
            startDate = record.startDate;
        }
        if (record.endDate > endDate) {
            endDate = record.endDate;
        }

    }

    var ReportedTime = new Object();
    ReportedTime.PeriodStartDate = (moment(startDate)).format("YYYY-MM-DDTHH:mm:ss");
    ReportedTime.PeriodEndDate = (moment(endDate)).format("YYYY-MM-DDTHH:mm:ss");
    // ReportedTime.PeriodStartDate =startDate;
    // ReportedTime.PeriodEndDate = endDate;

    ReportedTime.TimeIntervals = this.convertToTimeIntervals(records);


    return ReportedTime;


};
